// Generated by CoffeeScript 1.8.0
(function() {
  var buildStack, content, exit, json, options, page, paper, setContent, system, totalPages, type, vp, webpage, _i, _len, _ref, _ref1, _ref2, _ref3;

  system = require('system');

  webpage = require('webpage');

  exit = function(error) {
    var message;
    if (typeof error === 'string') {
      message = error;
    }
    if (error) {
      system.stderr.write("html-pdf: " + (message || ("Unknown Error " + error)) + "\n");
    }
    return phantom.exit(error ? 1 : 0);
  };

  buildStack = function(msg, trace) {
    var msgStack;
    msgStack = [msg];
    if (trace != null ? trace.length : void 0) {
      msgStack.push('Stack:');
      trace.forEach(function(t) {
        return msgStack.push("  at " + (t.file || t.sourceURL) + ": " + t.line + " (in function " + t["function"] + ")");
      });
    }
    return msgStack.join('\n');
  };

  phantom.onError = function(msg, trace) {
    return exit(buildStack('Script - ' + msg, trace));
  };

  setTimeout(function() {
    return exit('Force timeout');
  }, 120000);

  json = JSON.parse(system.stdin.readLine());

  if (!((_ref = json.html) != null ? _ref.trim() : void 0)) {
    exit('Did not receive any html');
  }

  options = json.options;

  page = webpage.create();

  page.content = json.html;

  if (vp = options.viewportSize) {
    page.viewportSize = vp;
  }

  totalPages = 0;

  page.onError = function(msg, trace) {
    return exit(buildStack('Evaluation - ' + msg, trace));
  };

  content = page.evaluate(function() {
    var $body, $footer, $header, body, footer, header, styles, _ref1;
    styles = ((_ref1 = document.querySelector('head style')) != null ? _ref1.outerHTML : void 0) || '';
    if ($header = document.getElementById('pageHeader')) {
      header = $header.outerHTML;
      $header.parentNode.removeChild($header);
    }
    if ($footer = document.getElementById('pageFooter')) {
      footer = $footer.outerHTML;
      $footer.parentNode.removeChild($footer);
    }
    if ($body = document.getElementById('pageContent')) {
      body = $body.outerHTML;
    } else {
      body = document.body.outerHTML;
    }
    return {
      styles: styles,
      header: header,
      body: body,
      footer: footer
    };
  });

  paper = {
    border: options.border || '0'
  };

  if (options.height && options.width) {
    paper.width = options.width;
    paper.height = options.height;
  } else {
    paper.format = options.format || 'A4';
    paper.orientation = options.orientation || 'portrait';
  }

  setContent = function(type) {
    var _ref1;
    return paper[type] = {
      height: (_ref1 = options[type]) != null ? _ref1.height : void 0,
      contents: phantom.callback(function(pageNum, numPages) {
        var _ref2;
        return (((_ref2 = options[type]) != null ? _ref2.contents : void 0) || content[type] || '').replace('{{page}}', pageNum).replace('{{pages}}', numPages) + content.styles;
      })
    };
  };

  _ref1 = ['header', 'footer'];
  for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
    type = _ref1[_i];
    if (options[type] || content[type]) {
      setContent(type);
    }
  }

  if ((_ref2 = paper.header) != null) {
    if (_ref2.height == null) {
      _ref2.height = '46mm';
    }
  }

  if ((_ref3 = paper.footer) != null) {
    if (_ref3.height == null) {
      _ref3.height = '28mm';
    }
  }

  page.paperSize = paper;

  page.onLoadFinished = function(status) {
    var fileOptions, filename;
    fileOptions = {
      type: options.type || 'pdf',
      quality: options.quality || 75
    };
    filename = options.filename || ("" + (options.directory || '/tmp') + "/html-pdf-" + system.pid + "." + fileOptions.type);
    page.render(filename, fileOptions);
    system.stdout.write(JSON.stringify({
      filename: filename
    }));
    return exit(null);
  };

}).call(this);
